module.exports = KVSet

function KVSet() {
  if (!(this instanceof KVSet)) return new Set()
  this.heads = {}
  this.tails = {}
}

KVSet.prototype.add = function (key, value) {
  if (key in this.tails) delete this.tails[key]
  else this.heads[key] = value
}

KVSet.prototype.remove = function (key) {
  if (Array.isArray(key)) {
    for (var i = 0; i < key.length; i++) this.remove(key[i])
  } else {
    if (key in this.heads) delete this.heads[key]
    else this.tails[key] = true
  }
}
