var test = require('tape')
var Set = require('.')

test('kvset', function (t) {
  var set = new Set()
  set.add(1, 'foo')
  t.deepEqual(set.heads, {1: 'foo'}, 'set head')
  set.add(2, 'bar')
  set.add(3, 'qux')
  t.deepEqual(set.heads, {1: 'foo', 2: 'bar', 3: 'qux'}, 'add more heads')
  t.deepEqual(set.tails, {}, 'no tails')
  set.remove(1)
  t.deepEqual(set.heads, {2: 'bar', 3: 'qux'}, 'remove a value')
  set.add(4, 'baz')
  t.deepEqual(set.heads, {2: 'bar', 3: 'qux', 4: 'baz'}, 'add a value')
  set.remove([4, 2])
  set.add(5, 'blah')
  t.deepEqual(set.heads, {3: 'qux', 5: 'blah'}, 'replace values')
  set.add(7, 'thing')
  set.remove([3, 8])
  t.deepEqual(set.heads, {5: 'blah', 7: 'thing'}, 'add thing with unknown link')
  t.ok(8 in set.tails, 'wait for tail')
  set.add(8, 'nop')
  t.deepEqual(set.heads, {5: 'blah', 7: 'thing'}, 'tail does not become a head')
  t.deepEqual(set.tails, {}, 'no tails')
  set.add(9, 'ok')
  set.remove(7)
  t.deepEqual(set.heads, {5: 'blah', 9: 'ok'}, 'replace single item')
  t.end()
})
